                     Computer Science 825
                           Quiz 1           Name _______________________

Terminology:  the very highest layer is the APPLICATION LAYER = Layer N
              the very lowest  layer is the PHYSICAL LAYER    = Layer 1

1. For each of the following application identify the most appropriate
   form of service:

   ___ a. Remote login      1. unreliable connectionless

                            2. reliable connection oriented
   ___ b. Audio & Video
          teleconferencing  3. reliable connectionless.

   ___ c. Electronic mail   4. unreliable connection
                               oriented.

2. a. Which of the seven layers of the ISO-OSI model is the LOWEST
      layer that is typically found in each host computer but not
      found in an IMP.



   b. Which of the seven layers of the ISO-OSI model was
      designated responsible for data encryption.



   c. Precisely why did military types find the designation in (b.)
      not very satisfactory.




3. Which of the following is not a disadvantage of incorporating
   network protocols directly into an application (as opposed to having
   a general networking subsystem in the OS).

   a. It makes it harder to migrate   b. It makes the performance of
      to new hardware technologies       the application worse.

   c. It takes longer to write        d. The applications tend to
      the applications.                  be less reliable.

4. We defined "protocol" to be a set of rules defining three
   characteristics of the messages transmitted through the network.
   Name these characteristics. Hint: they all start with "S".

   a.

   b.

   c.

5. The motivation for organizing network subsystems into protocol
   stacks was primarily to:

   a. Improve the message             b. Improve the logical organization
      throughput.                        of the software and make it
                                         easier to maintain and enhance.

   c. Both a. and b. equally.         d. Neither a. or b. was a factor.
  ----------------------- OVER to BACK------------------------------


6. For which two layers does the TCP / IP network architecture specify
   protocols.

   a. Data Link and Network      b. Application and Session

   c. Network and Physical       d. None of the above


7. For two separate implementations of a specific network
   architecture to interoperate correctly it is necessary that:

   a. Intra-level peer protocols  b. Inter-level interface
      be compatible                  definitions be comptatible

   c. Both a and b.               d. Neither a or b.

8. Protocol headers used by a layer N are handled by layer K (K < N)
   as follows:

   a. The are removed before  b. They are treated as user data.
      the packet arrives at
      Layer K

   c. They are deleted by layer K.



                      Computer Science 825
                         Quiz 2              Name _______________________

1. In the model of synchronous transmission that we described in class

   a. the clock on the receiver       b. the clock on the receiver
      modem was driven by the            USART was driven by the
      receiving USART.                   receiver modem.

   c. independent clocks were used    d. No clocking at all was
      in the modem and the USART.        required.

2. A "self clocking" modulation scheme is one which

   a. Ensures that the signal has     b. Uses phase modulation
      a detectable change of state
      every baud time.

   c. Both a. and b.                   d. Either a. or b.

3. What is the minimum SNR (in db) that will sustain a data rate of
   200,000 bits per second on a 5000hz channel?

















4. Suppose a channel is equipped with high and low pass filters
   that pass only harmonics in the range 20,000 hz to 24,000 hz.
   On this channel the MINIMUM sampling rate required to reconstruct
   the exact signalling function is closest to:

   a. 4000 samples / sec               b. 24000 samples / sec

   c. 8000 samples / sec               d. 48000 samples / sec.

5. Select the amount of time that independently running clocks in
   the sender and receiver must remain synchronized in the
   implementations of asynchronous and synchronous communications
   presented in class.

   ___ a. Asynchronous                 1. No time at all.
                                       2. One baud time.
   ___ b. Synchronous                  3. One bit  time.
                                       4. One byte time.
                                       5. One packet time.

6. a. How many signalling levels must be used to transmit 100,000 bits
      per second on a noise free channel that has a bandwidth of 10000hz.
      (Show work for partial credit).











    b. What would be the BAUD rate of a modem performing this function.




7. In the models of synchronous and asynchonous transmission
   signalling between the U(S)ART and modem using the RS-232 interface
   is best described as:

   a. Base band and parallel          b. Base band and serial

   c. Modulated carrier and parallel  d. Modulated carrier and serial.


8. The general form of a modulated sine wave carrier is
   f(t) = A sin(Wt + H).

   a. Which of the three parameters is varied in phase modulation?


   b. Which of the three parameters was NOT varied in either of the
      1200 bps or 9600 bps modulation schemes discussed in class.




                      Computer Science 825
                         Quiz 3              Name _______________________

1. Suppose a new  "high fidelity" voice telephone service has a bit rate
   of 400,000 bits per second. Each sample is digitized at a resolution
   of  4096  discrete levels.  What is the maximum frequency that
   can be carried by this channel?









2. The data rate available in the standard ISDN home user channel
   compares to generally available modems as:

   a. ISDN is about 5 times        b. ISDN is more than 100 times
      slower                          faster

   c. ISDN is about 2 to 3 times   d. ISDN is more than 100 times
      faster                          slower.


3. The class of data service provided by ISDN is best categorized as

   a. Connection oriented reliable   b. Connection less unreliable
      bit stream.                       datagram.

   c. Connection oriented unreliable d. Connection oriented reliable
      bit stream.                       datagram


4. Select the multiplexing scheme (FDM, ATDM, STDM) that applies
   in each of the following cases:

   a. The scheme most suitable for use with analog (as opposed
      to digital channel).


   b. The type of multiplexing that is, in effect, being used
      when multiple IBM type terminals are connected to a remote
      host computer through a single dedicated phone line.


   c. The type of multiplexing which imposes the LEAST overhead
      on the available bandwidth/bit rate.



5. The main advantage of using a multiplexor to attach a remote cluster of
   ASCII terminals to a Unix machine is that it reduces the required number of

   a. Computer ports            c. Ports and Phone lines.

   b. Phone lines.              d. Ports, phone lines and terminals.



6. The main reason digital channels have much lower error rates than analog
   when used over long distances is:

   a. Digital signalling is baseband   c. Digital signals are amplified
      instead of analog.                  rather than regenerated.

   b. Digital signals are regenerated  d. Digital channels have much higher
      rather than amplified.              SNR's than analog.


7. Suppose a network has links that carry data at a rate of 20,000
   bits per second.  Suppose Node A and Node B are connected by a
   path that requires 10 hops (retransmissions).

   a. What is the minimum time required to send a 1,000,000 bit message
      if message switching is used.







   b. Suppose packet switching is used and no additional bits are
      required for headers. How long will it take to send the entire
      message if 4000 bit packets are used.






   c. Suppose 400 bit headers are used in the packet switching
      scheme. Write a function  f(p) that gives the transmission
      time in terms of packet size.










                      Computer Science 825
                         Quiz 4              Name _______________________

1. Select the appropriate window of vulnerability for collision
   OCCURRENCE in each of the following MAC protocols: (n.b. the
   question says occurrence and not detection)

   ____ a. Pure aloha            1. One byte time
                                 2. One packet time
   ____ b. Slotted aloha         3. Two packet times
                                 4. The one way propogation delay
   ____ c. Ethernet style        5. The two way propogation delay
           CSMA-CD               6. Two times the bit rate

2. Measurements of an infinite user slotted aloha channel show that 30%
   of the slots are idle.

   a. What is the total load (mean number of transmission attempts per
      packet time) = G.







   b. What is the throughput??







   c. What is the expected number of attempts required for each
      successful transmission.






3. If K stations share a CSMA-CD bus and the probability that any station
   will transmit on a given contention slot is "p", then the probability
   that a successful transmission will take place in a slot is:

   a. p                           c. p * k * (1 - k) ^ (p - 1)

   b. k * p * (1 - p) ^ (k - 1)   d. None of the above.


4. If the probability computed above is denoted A, then the probability
   that a contention interval will last exactly j slots is:

   a. A ^ j  * (1 - A) ^ (j - 1)  c. A / j

   b. (1 - A) ^ (j - 1)            d. None of the above.

5. Suppose slotted aloha is being used on a satellite based network.
   If the bit rate is 100,000 bits per second and packets are 5000
   bits long. (Speed of light = 180,000 miles/sec).
   How long (physically in miles) is a packet traveling through space.






6. Answer the following T or F. (Assume only the parameter indicated
   is being varied and all of the others remain fixed in each case).

   ___ a. Increasing the length of a CSMA CD LAN will increase the length
          of the contention interval and thus make the efficiency of the
          LAN higher.

   ___ b. Decreasing the average packet size will tend to make the efficiency
          of a CSMA CD LAN higher.

   ___ c. Decreasing the bit transmission rate from 10 Mbps to 1 Mbps
          increase the efficiency of a CSMA LAN


7. Use of p-persistent CSMA compared to 1 persistent CSMA

   a. Make avg latency (response)      b. Make avg latency (response)
      higher and make throughput          lower but make throughput
      higher                              higher

   c. Make avg latency (response)      d. Make avg latency (response)
      higher but make throughput          lower and make throughput
      lower                               lower


8. In a dual persistent protocol a station transmits with prob p
   when it initially sense a channel idle and with prob q when
   it has to wait for a busy channel to become idle.  The proper
   relationship between p and q is:

   a. p < q                            b. p > q

   c. p = q                            d. q = 1 and p < q




                      Computer Science 825
                         Quiz 5              Name _______________________

1. For the IEEE token bus match the control packet that will be generated
   as a result of each of the following conditions.  Some answeres may
   be used 0 times or more than one time!

   ____ a. A station recognizes a WHO_FOLLOWS   1. SOLICIT_SUCCESSOR_2
           packet naming its predececessor.
                                                2. WHO_FOLLOWS
   ____ b. A station wishes to leave the net
           in an orderly way.                   3. SET_SUCCESSOR

   ____ c. A collision occurs when two          4. RESOLVE_CONTENTION
           stations try to claim the token
           at the same time.                    5. CLAIM_TOKEN

   ____ d. A station wishes to respond to a     6. SOLICIT_SUCCESSOR
           SOLICIT_SUCCESSOR frame.
                                                7. RESOLVE_SUCCESSOR
   ____ e. A station times out twice after
           sending a WHO_FOLLOWS frame.

2. In an 802.5 token ring system suppose the following events occur:

   Station A transmits to E using priority 1 token
   Station C makes a priority  5 reservation
   Station A generates a priority 5 token
   Station B transmits a priority 5 message to station C
   Station B transmits a priority 5 token
   Station C transmits a priority 5 message to station B

   Who is responsible for regenerating a priority 3 token?



3. Suppose bit transmission rate is 4,000,000 b.p.s and signal propogation is
   200,000 KM / sec. How long must a cable be to hold an entire 24 bit token.






4. With the priority schemes used in token bus and token ring it is
   possible to ensure that starvation of low priority traffic doesn't
   occur

   a. in token ring but                 b. in both token ring
      not in token bus.                    and token bus

   c. in neither token ring             d. in token bus but not
      nor token bus                        in token ring.

5. Dealing with "orphan frames" is a problem that must be dealt with

   a. in token ring but                 b. in both token ring
      not in token bus.                    and token bus

   c. in neither token ring             d. in token bus but not
      nor token bus                        in token ring.


6. Two standard measures of network performance are sustained throughput
   and mean packet delay. High sustained throughput is good and low mean
   packet delay is good.  For each of the following select the answer that
   bests compares CSMA/CD with token passing.

   a. Sustainable throughput at very high loads
      1. CSMA/CD is better          2. Token passing is better
      3. No measureable difference

   b. Packet delay at very high loads
      1. CSMA/CD is better          2. Token passing is better
      3. No measureable difference

   c. Sustainable throughput at very low loads
      1. CSMA/CD is better          2. Token passing is better
      3. No measureable difference

   d. Packet delay at very low loads
      1. CSMA/CD is better          2. Token passing is better
      3. No measureable difference


7. Suppose a token ring transmits data at a rate of 10,000,000 bits/sec.

   a. Suppose signal propogation speed is 200,000,000 m/sec and the
      stations on a token ring are an average of 40 meters distant
      from each other. How many microseconds does it take the signal
      to propogate from one station to another.






   b. Suppose the ring has 100 stations and each station introduces
      a propogation delay of 1 bit time. What is the average delay (in usec)
      experienced by a station after it becomes ready but before it
      can begin transmitting on an IDLE RING.




8. a. How would having the receiver be responsible for removing a frame
      from a token ring contribute to the "orphan frame" problem?




   b. Why does the use of a 1 bit store-and-forward buffer in the
      token ring interface make it not feasible for the receiver
      to be responsible for removing a frame?





                      Computer Science 825
                         Quiz 6              Name _______________________

1. Wide area networking requires both routing (switching) technologies
   and long haul transport technologies. The relationship between
   SONET and ATM in emerging long haul networks is:

   a. Both are competing switching     b. SONET is a routing technology
      technolgies                         but ATM is a transport technology

   c. ATM is a routing technology      d. Both are competing long haul
      but SONET is a long haul            transport technologies
      transport technology


2. Three methods of datalink framing that we discussed were:
   bit stuffing, byte stuffing, and byte count. What was the other?




3. Suppose the following bit sequence is subject to SDLC style
   bit stuffing.. How many bits will actually be transmitted?

                        2         1
                  65432109876543210987654321
                  --------------------------
    Last bit -->  11100111111101111011111000 <- First bit transmitted



4. Suppose a 15 bit codeword with ODD parity is being used in a
   single bit hamming ECC.  Suppose the  following codeword is
   received.

      X  X  0     1  0  1     1  1  1  0  0  1  1
      --------------------------------------------
      1  2  3  4  5  6  7  8  9 10 11 12 13 14 15

   a. Fill in the  missing ECC bits above ..



   b. Suppose a single bit Hamming ECC is to be performed on a
      1023 bit codeword.  How many bits are in each of the 10
      parity checked groups (include the parity bit itself).



   c. Suppose a two bit error occurs. Circle the correct description
      of the result.

      1. The fact that there is a two error can be detected, but the
         error can't be corrected.

      2. The two error will be undetected and the value that results
         from the correction process will be a legal code word but it
         will be the wrong one.

      3. The two error will be undetected and the corrected value will
         be either the wrong codeword or it might be the correct codeword.

      4. The two error will be undetected and the corrected value MAY
         be an illegal code word.

    c. What is the minimum Hamming distance of a code that is capable
       of doing triple bit error detection NNOOTT CCOORREECCTTIIOONN!!




6. Suppose 1800 bit code words are to be transmitted and it is desired
   to use a Hamming code to correct single error bursts of up to 30 bits.
   How many of the 1800 bits must be used for ECC. (Hint: Fractional
   bit based strategies are not encouraged!)




7. In the channel allocation strategy known as Crowther's method all
   packet slots are initially contention slots and a station that
   successfully transmits in a slot own's it the next group.  Which
   of the following is NOT an advantage of using Crowther's method.

   a. Under heavy loads it is possible    b. It is not necessary to
      to support much higher throughput      know the number of competing
      than with Aloha.                       stations in advance.

   c. Like TDM it automatically ensures   d. All of the above ARE
      that slots will be exactly evenly      advantages
      divided among all stations.





                      Computer Science 825
                           Quiz 7          Name _______________________

1. Consider the following shift register:




   a. What will be the contents of the shift register after the
      input digits 1 and 0 are processed.









   b. What generator polynomial is represented by this shift register.






   c. Does this shift register represent standard long division  or
      is it the pre-multiplying version? (Yes in not the correct answer).





2. What characteristic of a generator polynomial will ensure that
   every error in which an odd number of bits are inverted will be
   detected?




3. In protocol 1 in the book, frames didn't carry sequence #'s and no ACKS
   or CRC's were used.  Which of the following is NOT a disadvantage
   of the use  of protocol 1.

   a. A fast sender could overrun   b. Undetected duplications of
      a slow receiver                  packets could take place.

   c. Packets could be lost.        d. Damaged packets could be
                                       accepted.


4. In protocol 2, ACK's were used but no sequence numbers were used
   on frames or ACK's.  Which of the following problems could occur.

   a. Lost frames would go          b. Lost ACK's would result in
      undetected.                      lost frames

   c. Lost acks would result in     d. Lost frames would result in
      duplicate frames.                duplicate frames.


5. In protocol 3, frames's had sequence numbers but ACKS did not.
   Protocol 3 could fail in the presence of:

   a. ACK's that were lost          b. ACK's that were excessively
                                       delayed

   c. Frames that were lost.        d. Either a or b

6. The bisynch protocol introduced the use of the ENQ packet.
   An ENQ is used

   a. To request that the last      b. To request that the last
      ACK be retransmitted.            packet be retransmitted

   c. To resynchronize sequence     d. All of the above.
      numbers

7. Suppose a generator polynomial of G(x) = x^4 is used. G(x)
   can detect

   a. All errors involving any of   b. Some, but not all, of the errors
      the last 4 bits of the message   involving the last 4 bits of the
      and some errors not involving    message some but not all of the
      any of the last 4 bits.          errors that don't involve the last
                                       4 bits.

   c. All errors involving the      d. All single bit errors but no more
      last 4 bits of the message       than that.
      but no errors that do not
      involve the last 4 bits.



                      Computer Science 825
                           Quiz 8          Name _______________________

1. Show how a sliding window protocol that uses a 3 bit sequence
   number, a sender window size of 6, and a receiver window size of 3
   can fail.















2. Suppose that a satellite channel is in use and the EARTH to SATELLITE
   propogation delay is 120 ms.  Suppose bit transmission rate is 200,000
   bits per second and packets are 4000 bits long.

   a. What will the efficiency of this channel be if stop and wait
      protocal is used.



   b. How large (in packets) must the SWS be in order to obtain 100%
      efficiency if the channel is guaranteed error free. (i.e. give
      me the MINIMUM SWS I can use).




   c. How large (in packets) must the RWS be in order to obtain 100%
      efficiency if the channel is guaranteed error free. (i.e. give
      me the MINIMUM RWS I can use).




   d. How many bits will be required in the sequence if the selective
      reject sliding window protocol is used and 100% utilization is
      to be achieved in the absence of errors.





4. For each of the following combinations of propogation delay
   and error rate identify the most suitable variation of sliding
   window protocol. (The most suitable choice is the SIMPLEST
   one that doesn't incur a big performance penalty.)

   ___ a. No errors but very long     1. Stop and Wait
          propogation delay
   ___ b. No errors and negligable    2. Go back N
          propogation delay.
   ___ c. High errors and very long   3. Selective repeat
          propogation delay
                                      4. Selective reject.


5. Identify two deficiencies of the protocol 5 implementation that
   would HAVE TO BE corrected before it could be successfully used
   in a real network.

   a.



   b.

6. A buffer in the protocol discussed in class cycled though a number
   of queues.. Associate each transition with the process that
   caused it. (Some answers may be used more than once or not at all).

      ____ 1. Read pending to network      a.  Writelink process
              input.

      ____ 2. Network input to link        b.  Readlink process
              station output
                                           c.  Timeout process
      ____ 3. Link output to
              sender window.               d.  Network layer process

       ___ 4. Sender window to free        e.  Queuemsg process
              list

7. The protocol discussed in class became deadlocked when

   a. Any readlink process became       b. All readlink processes became
      blocked in dequeue.                  blocked in dequeue,

   c. Any time an ACK was lost          d. Never

8. The sender window logic used three indexes: nxtsend; nxtqueue; and
   nxtack. We said these values always remained in a specific relative
   order. The order was

   a. send <= queue <= ack              b. queue <= ack <= send

   c. ack <= queue <= send              d. ack <= send <= queue




                      Computer Science 825
                           Quiz 9          Name _______________________


1. The address byte in an SDLC packet always carries the address of

   a. The sender                 b. The receiver

   c. The primary station.       d. The secondary station.

2. Select the description which most accurately matches the use of
   the P/F bit in SDLC.

   a. 1 -> Poll and 0 -> Final    b. The bit means poll or not poll
                                     when a secodary sends final or
                                     not final when a primary sends.

   c. The bit means poll or not   d. The bit means poll or not poll
      poll to the sender final       when the primary sends final or
      or not final to the receiver   not final when a secondary sends.


3. Unnumbered frames in SDLC carry

   a. Both sequence numbers and    b. Sequence numbers but no ack
      ack numbers.                    numbers

   c. Ack numbers but no sequence  d. No numbers at all.
      numbers.

4. Which of the following is NOT a use of supervisory frames in SDLC

   a. Sending a standalone ack     b. Seeing if another station is
                                      back up after a crash.

   b. Polling                      d. Telling another station to
                                      temporarily stop sending.


5. Which of the following messages has suitable semantics for the
   unnumbered protocol. Hint: This question is NOT asking what
   specific frame types are in SDLC.  It IS asking what limitations
   are on the semantics of messages in protocols in which frames
   and acks carry no numbers.

   a. Set current seq # to 0.      b. Add 1 to current seq #.

   c. Both a and b.                d. Neither a nor b.

6. Suppose unnumbered frames were given sequence numbers and ACK numbers
   just like data frames and that the receiver of an out of sequence
   unnumbered frame would discard it just as it would an out of sequence
   data frame. Would this make the functions performed with unnum frames
   work:

   a. Much better and more         b. Work worse and less reliably.
      reliably.

   c. Make no appreciable difference.

7. Identify the class of service provided to the transport layer
   by each of the following network layers.


   ___ a. IBM SNA                 a. Unreliable connection oriented

   ___ b. Internet Protocol       b. Reliable connection oriented

   ___ c. BISDN (ATM)             c. Unreliable connectionless

                                  d. Reliable connectionless

8. The relationship between error rate and the desirability of using
   a reliable connection oriented network layer versus an unreliable
   datagram oriented network layer is that:

   a. Many hops with high error     b. Many hops with high error
      rates favors datagram service    rates favors reliable connection
                                       oriented service.

   c. The number of hops and the
      error rates have no particular
      effect.


Suppose the probability of succeeding at a given endeavor is "p".
Then it is easy to show that the expected number of attempts needed
to achieve success is 1/p.

Suppose two stations are connected by a path that is N hops long and
the probability of a successful transmission over each hop is p.

9. The expected number of total transmissions to get a packet from
   one end to the other if a reliable network layer is used is:
   (The reliable network repeats transmissions at each hop until it
    succeeds).

   a. 1 / p                          b. 1 / Np

   c. N / p                          d. p / N

10. The expected number of total transmissions to get a packet from
    one end to the other if an unreliable network layer is used is:
    The unreliable network layer just discards failed transmissions
    and depends on the transport layer to start over from the beginning
    if a packet doesn't succeed in making the whole trip)

   a. 1 / p^N                        b. N / (2 p ^ N)

   c. N ^ p / 2 ^ N                  d. N ^ p / p










                      Computer Science 825
                         Quiz B           Name _______________________

1. Suppose the Bellman-Ford routing algorithm is being used and station
   B receives the following routing updates from neighbors A, C and E
   Suppose BA delay = 3, BC delay = 6 and BE delay = 5.
   Complete the routing table for B.,

      A  C  E      Cost VIA
   A  0  6  9          |
   ------------   ----------
   B  5 11  2          |
   ------------   ----------
   C  3  0  9          |
   ------------   ----------
   D  8  5  2          |
   ------------   ----------
   E  6  8  0          |
   ------------   ----------
   F 11  2  7          |
   ------------   ----------

3. Suppose a new virtual circuit is to be set up and that it goes
   from the host at switch D to the host at switch E following the
   route D -> F -> B -> A -> E.  Update the VC assignment tables.






















4. Order the following broadcast algorithms according to the number
   of packet transmissions needed to complete a broadcast (1 = least
   transmissions; 3 = most).

   ______ a. Reverse Path Forwarding

   ______ b. Spanning tree.

   ______ c. Flooding



5. Suppose network addresses are 24 binary digits and all network
   addresses are in use.

   a. How many entries must a flat routing table have. (A flat
      routing table has an entry for each node in the network).



   b. Suppose a hierarchichal addressing/routing scheme is used
      in which the 24 bits are partitioned as a 6 digit region
      code followed by a 8 digit locality code followed by a 10 digit
      local address.  How many routing table entries are now
      required?



6. In another network that uses SPF suppose station A constructs the
   following cost matrix

       A   B   C   D   E

   A   0   2   -   3   4

   B   2   0   6   -   9

   C   -   6   0   7   2

   D   3   -   7   0   4

   E   4   9   2   4   0


   Draw the routing tree from node C to all destinations.
   Label the ARCs of the graph in the order in which they
   are made permanent in the SPF algorithm.


7. Let N = number of nodes in a network and M = the average number
   of links / node.

   a. The size of a routing info packet in Bellman-Ford is of order

      1. M      2. N      3. N ^ 2       4. N ^ M

   b. The size of each routing update packet transmitted in an SPF net is
      of order

      1. M      2. N      3. N ^ 2       4. N ^ M


   c. In terms of computational complexity the SPF algorithm as performed
      by a single node is of order.

       1. M    2. N     3. N ^ 2    4. M ^ 2    5. N ^ M


   d. The minimum number of routing packets transmissions at each complete
      exchange in SPF within the entire network is of order:

       1. M    2. N     3. N ^ 2    4. M ^ 2    5. N * M








                      Computer Science 825
                         Quiz B           Name _______________________

1. Which routing algorithm is used by the spanning tree bridge
   if the location of the destination node is unknown?

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Shortest past first.

2. Which routing algorithm does the spanning tree bridge employ
   in order to minimize the occurrences of destination unknowns.

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Bellman-Ford.

3. The use of the spanning tree algorithm on the transparent
   bridge is necessary

   a. Any time more than two      b. Any time the bridges are
      networks are bridged.          connected in such a way that
                                     a loop or cycle exists in the net.

   c. Both a. and b.              d. Neither a. nor b.

4. When a bridge port is not included in the spanning tree the
   bridge:

   a. Doesn't receive data on it    b. Doesn't transmit data on it

   c. Both a. and b.                d. Neither a. nor b.

5. Which routing algorithm is used by the source routing bridge
   in routing "discovery" packets to the destination.

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Shortest path first.

6. Identify ALL environments in which preallocation of buffers is
   a feasible way in which to do congestion control.

   a. Unreliable datagram            b. Unreliable connection oriented.

   c. Reliable connection oriented.


7. Identify ALL environments in which packet discarding is
   a feasible way in which to do congestion control.

   a. Unreliable datagram            b. Unreliable connection oriented.

   c. Reliable connection oriented.

8. Choke packets are sent:

   a. from an imp experiencing    b. To an IMP experiencing
      congestion to the source       congestion from the source
      host of a packet.              host of a packet.

   c. From an IMP experiencing    d. To an IMP experiencing
      congestion to the dest         congestion from the dest
      host of a packet.              host of a packet.

9. In the heirarchical buffer allocation algorithm of Merlin and Schweitzer
   the number of buffers at each routing node has a greatest lower bound of:

   a. 1                              b. The number of nodes in the
                                        network.

   c, The maximum number of packets  d. The maximum length in hops of
      in the network at any one time.   of any route in the network.


10. Describe what is meant by the term "reassembly deadlock". Illustrate
    your description with a diagram.



                      Computer Science 825
                         Quiz C           Name _______________________

1. If multiple Links exist between SNA nodes, it is possible to group them
   all into a single transmission group or to create as many transmission
   groups as there are links.. What is the advantage of each approach.


   a. Single TG



   b. As many TG's as Links




2. Suppose the following is a diagram of an SNA network:

     A       D
   /   \   /   \
  Z      C      F
   \   /   \   /
     B       E

    Answer the following T or F.

    ___ a. Nodes Z and C can't both have explicit routes with the
           identity (3, F).

    ___ b. For node A to have a functional explicit route with
           identity (3, F), node C must also have an explicit route
           with identity (3, F).

    ___ c. Nodes A and C can't both have explicit routes with the
           identity (3, F) where A's (3,F) passes through D and
           C's (3, F) passes through E.

    ___ d. If nodes A and B can both have explicit routes to F with A's
           called (3, F) and B's called (4, F), the reverse route to
           a must be called (3, A) and the reverse route to be must
           be called (4,B).


3. Suppose nodes C, D, and F's static tables contain the following
   entries:

        Dest ER#  Via/TG        Dest ER#  Via/TG     Dest ER#  Via/TG
    C:   A    2    1        D:   A    2    1     F:   A    7    1
         A    7    2             A    9    1          A    8    2
         A    9    2             A   11    1          A    9    2

  If A activates (7,F) what are the possible ER numbers for the reverse ER??



4. A VR manager receiving a packet with the Change Window Reply Indicator
   must:

   a. Stop sending immediately   b. Set the current pacing group size
                                    to the minimum pacing group size.

   c. Decrement the current      d. Increment the current pacing group
      pacing group size.            size.

5. A VR manager receiving a packet with the Reset Window Indicator
   must:

   a. Stop sending immediately   b. Set the current pacing group size
                                    to the maximum pacing group size.

   c. Decrement the current      d. None of the above.
      pacing group size.

6. When a VR manager receives a pacing response before the pacing
   count reaches 0 and it doesn't contain CRWI or RWI it

   a. Sets the pacing count to   b. Increments the current pacing
      the current pacing group      group size by 1.
      size.

   c. Adds the current pacing    d. Sets the pacing count to the
      group size to the pacing      maximum pacing group size.
      count.

7. a. What is the maximum number of networks and hosts for each of
      the three classes of network used in the INTERNET

                 Max Nets            Max Hosts
   Class A

   Class B

   Class C

   b. Which class of net does a node whose address is 192.215.17.139
      belong to.




8. What is the function of the "protocol" byte  found in the
   IP header?




                      Computer Science 825
                         Quiz D           Name _______________________

1. Suppose Tomlinson's clock proposal is used with a 16 bit sequence
   number and a clock that ticks 1024 times a second. Suppose maximum
   packet lifetime is 9 seconds.

   a. What is the MINIMUM amount of time that can elapse before
      sequence number resynchronization must occur.














   b. How often will synchronization be needed if a packet is generated
      every 8 ticks (8 / 1024 seconds).














   c. Suppose the bit transmission rate is 2^20 bits per second
      and that all packets are the same size.  What is the minimum
      packet size that permits full channel untilization WITHIN THE
      CONSTRAINTS IMPOSED BY TOMLINSONS algorithm.






2. Which of the following following techniques was NOT suggested
   as a possible mechanism for addressing the delayed duplicate problem.

   a. Associate an incarntation      b. Use a unique transport connection
      number with each session.         addresses for each new session.

   c. Try to constrain the lifetime  d. Always use sequence number 0 when
      of all packets in the network.    starting a new session so that there
                                        can be no ambiguity at session start.

Suppose a 3 way handshake is being used to establish a connection.
Let SYN-1 represent a packet that carries SYN and no ack.
Let SYN-2 represent a packet that carries both SYN and ACK that is
sent in response to a SYN.

3. A delayed duplicate SYN2  received in the SYN-sent state is
   detected because:

   a. The SEQ number is wrong.   b. The ACK number is wrong.

   c. Both SEQ and ACK are       d. SYN2 is an unexpected packet
      known to be wrong.            in the SYN sent state.

4. A delayed duplicate SYN2 received in the CLOSED / LISTEN state is
   detected because:

   a. The SEQ number is wrong.   b. The ACK number is wrong.

   c. Both SEQ and ACK are       d. SYN2 is an unexpected packet
      known to be wrong.            in the CLOSED/LISTEN State.

5. A delayed duplicate SYN1 received in the ESTABLISHED state is:

   a. Responded to with RESET.   b. Responded to with a data packet
                                    specifying current ACK and SEQ.

   c. Responded to with SYN2     d. Always causes TCP to crash.


6. The ISO defined 5 classes of Transport protocol. Class 0 was really
   dumb and just attempted to pass packets up and down. At the other
   end of the spectrum Class 4 was like TCP and performed every sort of
   recovery known to man.  What were the two services provided by
   the classes 1 and 2. (Class 3 performed both.)

   a.


   b.




                      Computer Science 825
                         Quiz E           Name _______________________

1. Suppose a TCP connection has SND.UNA = 2200 and SND.NXT = 3450 and
   a packet arrives with ACK = 2800 and WINDOW = 4000. What size are
   the offered and usable windows now?

   offered -


   usable -


2. If IP loses a packet on a TCP connection, TCP recovers because

   a. The receiver always sends      b. The sender will eventually
      a special NAK packet if           time out and retransmit the
      a packet arrives out of           lost packet.
      order.

   c. Both mechanisms (a.) and (b.)  d. None of the above... TCP is
      are used.                         unable to recover from lost
                                        packets.

3. If a TCP receives a packet whose sequence number is less than its
   its current "ack" number   it should:

   a. buffer the packet but not      b. Buffer the packet and update
      change its current "ack"          it ack number to 1 + last byte
      ack number.                       received in the packet.

   c. discard the packet and not     d. Either b. or c. can be done.
      change its ack number.

4. If a TCP receives a packet whose sequence number is greater than
   its current "ack" number but still within the receiver window
   it should:

   a. buffer the packet but not      b. Buffer the packet and update
      change its current "ack"          it ack number to 1 + last byte
      ack number.                       received in the packet.

   c. discard the packet and not     d. Either b. or c. can be done.
      change its ack number.

5. Actions can be taken by either a sender or a receiver to terminate
   the dreaded condition known as the "Silly Window Syndrome". What
   action can each take.

   a. Sender -




   b. Receiver -





6. In Socket level TCP/IP programming the selection of the UDP or TCP
   transport protocol is made in which of the following function calls:

   a. socket()                   b. bind()

   c. connect()                  d. listen()


7. For each of the following functions indicate S if the function is
   used in constructing a TCP/IP server such as the one we studied,
   C if it is used in the client, and B if it is used in both the
   client and server.

   ____ a. accept()

   ____ b. connect()

   ____ c. bind()

   ____ d. socket()

   ____ e. listen()


8. Suppose round trip transit time for a connection is 40 milliseconds
   and the the transmission rate is 600,000 bytes per second. What
   is the minimum size (in bytes) that a TCP flow control window must be
   for the sender to avoid waiting after each window is sent.








